        @@ skip the emacs mode line
@@@ -*- Mode:Asm Mode:outline-minor-mode outline-regexp:"@@@+" comment-start: "@ " -*-

@@@ Frank Sergeant  frank@pygmy.utoh.org
        
@@@ cm3.asm
@@@ Equates specific to All Cortex-M3 s
@@@ All of these parts have an NVIC and a systick timer.

        @@ STK (SysTick timer)
        @@ see STK register map in section 4.5.6 (page 152) of programming manual
        .equ STK_BASE, 0xE000E010
        .equ STK_CTRL ,   STK_BASE +    0 @  SysTick control and status register
                                          @    uses processor clock (AHB) by default.
                                          @    Set bit 0 to enable.  reset value 0x0000 0004
        @@ I do not seeing a reset value of 0x0000 0004.  I see 0x0000 0000.  So, be sure
        @@ to set the bits explicitly.
          .equ STK_COUNTFLAG, BIT16  @ hardware sets it to '1' if timer counted to zero since the
                                     @ last time this bit was read.
          .equ STK_CLKSOURCE, BIT2   @ 0 = AHB/8,  1 = processor clock (AHB)
          .equ STK_TICKINT,   BIT1   @ 1 = enable interrupt flag
          .equ STK_ENABLE,    BIT0   @ 1 = enable timer 

        
        .equ STK_LOAD ,   STK_BASE +    4 @  SysTick reload value register (24 bits)
        .equ STK_VAL ,    STK_BASE +    8 @  SysTick current value register (24 bits)
        .equ STK_CALIB ,  STK_BASE + 0x0C @  SysTick calibration value register

        @@ set following define at least temporarily so kernel.fth can continue to
        @@  use T1TC to refer to read the counter value
        .equ T1TC, STK_VAL

        @@ table on page 129 the base addresses on page 106 seem inconsistent?
        @.equ NVIC_BASE, 0xE000E100
        @.equ NVIC_BASE, 0xE000EF00

        @@ SCB (System Control Block)
        @@ see SCB register map in section 4.4.14 (page 147) of programming manual
        .equ SCB_BASE, 0xE000ED00
        .equ SCB_CPUID,   SCB_BASE +    0
        .equ SCB_ICSR,    SCB_BASE +    4 @ interrupt control and state register
        .equ SCB_VTOR,    SCB_BASE +    8 @ vector table offset register
        .equ SCB_AIRCR,   SCB_BASE + 0x0C @ application interrupt and reset control register
        .equ SCB_SCR,     SCB_BASE + 0x10 @ system control register
        .equ SCB_CCR,     SCB_BASE + 0x14 @ configuration and control register
        @@ skip the SCB_SHPR* etc for now

        @@ Memory protection unit table on page 118
        @.equ MEM_BASE, 0xE000E100

        
